
	-- INITIAL VARIABLES --

-- Lets add all the watched players in this table --

charactersTable = {}
removedTable = {}

-- Create initial frame that retrieves Savedvariables and Creates the main addon frame --

init_frame = CreateFrame("Frame", "Initial_Frame", UIParent)
init_frame:RegisterEvent("ADDON_LOADED")
init_frame:SetScript("OnEvent", function() createAndLoad() end)

-- Creates main frame, positions and add events --


function createAndLoad()

	init_frame:UnregisterEvent("ADDON_LOADED")
	
	if positionXaxis == nil and positionYaxis == nil then
		positionXaxis = 0
		positionYaxis = 0
	end
	
	if sizeXaxis == nil and sizeYaxis == nil then
		sizeXaxis = 150
		sizeYaxis = 100
	end

	EyeOn = CreateFrame("Frame", "EyeOn", UIParent)
	EyeOn:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = false, tileSize = 0, edgeSize = 1, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
	EyeOn:SetBackdropColor(0,0,0,0.6)
	EyeOn:SetSize(sizeXaxis, sizeYaxis)
	EyeOn:SetPoint("CENTER", UIParent, "CENTER", positionXaxis, positionYaxis)
	EyeOn:RegisterEvent("UNIT_POWER_UPDATE")
	EyeOn:SetScript("OnEvent", function() updateResource() end)
	EyeOn:SetMovable(true)
	EyeOn:EnableMouse(true)
	EyeOn:SetResizable(true)
	EyeOn:RegisterForDrag("LeftButton")
	EyeOn:SetScript("OnDragStart", EyeOn.StartMoving)
	EyeOn:SetScript("OnDragStop", EyeOn.StopMovingOrSizing)
	EyeOn:SetMinResize(150, 50)
	
	EyeOn.resizeButton = CreateFrame("Button", nil, EyeOn)
	EyeOn.resizeButton:SetSize(16, 16)
	EyeOn.resizeButton:SetPoint("BOTTOMRIGHT")
	EyeOn.resizeButton:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Up")
	EyeOn.resizeButton:SetHighlightTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Highlight")
	EyeOn.resizeButton:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Down")
	EyeOn.resizeButton:SetScript("OnMouseDown", function(self, button)
		EyeOn:StartSizing("BOTTOMRIGHT")
		EyeOn:SetUserPlaced(true)
	end)
	EyeOn.resizeButton:SetScript("OnMouseUp", function (self, button)
		EyeOn:StopMovingOrSizing()
	end)
	
	EyeOn.title = EyeOn:CreateFontString(nil, "OVERLAY")
	EyeOn.title:SetFontObject("GameFontNormalSmall")
	EyeOn.title:SetPoint("CENTER", EyeOn, "TOP", 0, -10)
	EyeOn.title:SetText("EyeOn")
	
	EyeOn.avarageMana = EyeOn:CreateFontString(nil, "OVERLAY")
	EyeOn.avarageMana:SetFontObject("GameFontNormalLarge")
	EyeOn.avarageMana:SetPoint("CENTER", EyeOn.title, "BOTTOM", 0, -20)
	EyeOn.avarageMana:SetText("Avarage : 0 %")
	
	print("EyeOn LOADED!")
end


-- Command Table - Self explanetory --

commandTable = {["show"] = function()
					EyeOn:Show()
				end,
				["hide"] = function()
					EyeOn:Hide()
				end,
				["add"] = function(text)
					addPlayer(text)
				end,
				["remove"] = function(text)
					removePlayer(text)
				end,
				["hidenames"] = function()
					hideNames()
				end,
				["shownames"] = function()
					showNames()
				end,
				["reset"] = function()
					resetTable()
				end,
				["position"] = function(text)
					changePosition(text)
				end,
				["size"] = function(text)
					changeSize(text)
				end,
				["help"] = function()
					printHelp()
				end
				}
				
SLASH_EyeOn1 = "/eyeon"
SLASH_EyeOn2 = "/eon"
SlashCmdList["EyeOn"] = function(text)
	commandExecute(text)
end

-- Class Color Table --

classColorTable = {["DEATH KNIGHT"] = "|cFFC41F3B",
				["DENON HUNTER"] = "|cFFA330C9",
				["DRUID"] = "|cFFFF7D0A",
				["HUNTER"] = "|cFFABD473",
				["MAGE"] = "|cFF69CCF0",
				["MONK"] = "|cFF00FF96",
				["PALADIN"] = "|cFFF58CBA",
				["PRIEST"] = "|cFFFFFFFF",
				["ROGUE"] = "|cFFFFF569",
				["SHAMAN"] = "|cFF0070DE",
				["WARLOCK"] = "|cFF9482C9",
				["WARRIOR"] = "|cFFC79C6E"
				}
	
-- Executes the slash commands. --
-- Argument - Player entered text. --
	
function commandExecute(text)
	local command, parameters = strsplit(" ", text, 2)
	local entry = commandTable[command:lower()]
	local which = type(entry)
	if which == "function" then
		entry(parameters)
	elseif which == "table" then
		commandExecute(parameters, entry)
	end
end

function addPlayer(text)
			
	local players = {strsplit(" ", text)}
	
	for key, newCharacter in pairs(players) do
	
		isInRemovedTable = 0
	
		playerToAdd = newCharacter:gsub("^%l", string.upper)
		
		for characterKey, oldCharacter in pairs(removedTable) do
			if playerToAdd == oldCharacter then
				isInRemovedTable = 1
			end
		end
		
		isInCurrentTable = 0
		
		for key, currentCharacter in pairs(charactersTable) do
			if playerToAdd == currentCharacter then
				isInCurrentTable = 1
			end
		end
		
		if isInCurrentTable == 0 then
			if isInRemovedTable == 1 then
				characterToAddFrame = _G[playerToAdd]
				table.remove(removedTable, key)
				table.insert(charactersTable, playerToAdd)
				characterToAddFrame:Show()
				print(playerToAdd ..  " added to the Watch List")	
			else
				playerButton = CreateFrame("Button", playerToAdd, EyeOn)
				playerButton:SetSize(25, 25)
				playerButton:SetNormalFontObject("GameFontNormalSmall")
				table.insert(charactersTable, playerToAdd)
				print(playerToAdd ..  " added to the Watch List")
			end
		else
			print("Character already in EyeOn watch list.")
		end		
	end
	
	updateResource()
end

function removePlayer(text)
	local players = {strsplit(" ", text)}
	for key, value in pairs(players) do
		playerToRemove = value:gsub("^%l", string.upper)
		for characterKey, character in pairs(charactersTable) do
			if character == playerToRemove then
				print("Adding to removedTable")
				table.insert(removedTable, character)
				print("Hiding frame")
				characterToRemoveFrame = _G[character]
				characterToRemoveFrame:Hide()
				table.remove(charactersTable, characterKey)
				print("Removed from charactersTable")
				updateResource()
			end
		end
	end
end

function resetTable()
	for i=1, #charactersTable do
		playerToRemove = _G[charactersTable[1]]
		playerToRemove:Hide()
		table.insert(removedTable, charactersTable[1])
		table.remove(charactersTable, 1)
	end
	updateResource()
end


function changePosition(position)
	local positionx, positiony = strsplit(" ", position, 2)
	EyeOn:SetPoint("CENTER", UIParent, "CENTER", positionx, positiony)
	positionXaxis = positionx
	positionYaxis = positiony
end

function changeSize(size)
	local x, y = strsplit(" ", size, 2)
	EyeOn:SetSize(x, y)
	sizeXaxis = x
	sizeYaxis = y
end

function printHelp()
	print("/eyeon add <player> - Add character to the watch list by name. Can add multiple characters at once if SPACE seperated.")
	print("/eyeon remove <player> - Removes specific character. Can remove multiple characters at once if SPACE seperated.")
	print("/eyeon hidenames - Hide all character names.")
	print("/eyeon shownames - Shows all character names.")
	print("/eyeon reset - Removes all the players from watch list.")
	print("/eyeon hide - Hide EyeOn window.")
	print("/eyeon show - Show Eyeon window.")
end

function showNames()
	for key, character in pairs(charactersTable) do
		nameToShow = _G[character]
		nameToShow:Show()
	end
end

function hideNames()
	for key, character in pairs(charactersTable) do
		nameToHide = _G[character]
		nameToHide:Hide()
	end
end

function classColor(key)
	localizedClass, englishClass = UnitClass(charactersTable[key])
	for class, color in pairs(classColorTable) do
		if class == englishClass then
			return color
		end
	end
end
	


function updateResource()

	characterTextOffset = -20
	
	eyeonSizeY = 60

	maxMana = 0
	currentMana = 0
	
	for key, character in pairs(charactersTable) do
		playerButton = _G[character]
		playerButton:SetPoint("CENTER", EyeOn.avarageMana, "BOTTOM", 0, characterTextOffset)
		characterTextOffset = characterTextOffset - 20
		eyeonSizeY = eyeonSizeY + 20
		maxPower = UnitPowerMax(character, Mana, false)
		currentPower = UnitPower(character, Mana, false)
		manaPercent = math.floor(currentPower * 100 / maxPower)
		maxMana = maxMana + maxPower
		currentMana = currentMana + currentPower
		if manaPercent > 74 then
			playerButton:SetText(classColor(key) .. character .. " - |cFF00FF00" .. manaPercent .. " %")
		elseif manaPercent > 25 then
			playerButton:SetText(classColor(key) .. character .. " - |cFFFFFF00" .. manaPercent .. " %")
		elseif manaPercent > 10 then
			playerButton:SetText(classColor(key) .. character .. " - |cFFFF0000" .. manaPercent .. " %")
		else
			playerButton:SetText("|cFFFF0000" .. character .. " - " .. manaPercent .. " %")
		end	
	end
	
	local width, height = EyeOn:GetSize()
	if height < eyeonSizeY then
		EyeOn:SetSize(width, eyeonSizeY)
	end
	
	EyeOn:SetMinResize(width, eyeonSizeY)
	
	avarageManaPercent = math.floor(currentMana * 100 / maxMana)
	avarageManaText = "Avarage : 0 %"
	
	if table.getn(charactersTable) <= 0 then
		EyeOn.avarageMana:SetText("|cFF00FF00Avarage : " .. " %")
	elseif avarageManaPercent >= 75 then
		EyeOn.avarageMana:SetText("|cFF00FF00Avarage : " .. avarageManaPercent .. " %")
	elseif avarageManaPercent >= 20 then
		EyeOn.avarageMana:SetText("|cFFFFFF00Avarage : " .. avarageManaPercent .. " %")
	else
		EyeOn.avarageMana:SetText("|cFFFF0000Avarage : " .. avarageManaPercent .. " %")
	end	
end
	



